#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use strict;
use HTML::Template;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Config qw(%config);
use PureMessage::Manager::Lang;
use PureMessage::Service;
use PureMessage::Manager::Response::Services::Sendmail;
use PureMessage::Service::Sendmail qw(smconfNewer);
use PureMessage::Manager::Widget;
use PureMessage::Manager::Widget::Form;

my %vars;
our %text;

my $WIDGET = new PureMessage::Manager::Widget;


my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Sendmail',
                                'stderr_to_stdout' =>1
                              );

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_sendmail" );

$r->title(text('index_title'));

my @services = PureMessage::Service->Available;
my @sendmail = grep { $_->type eq 'smtp' && $_->name eq 'Sendmail' } @services;
my %sendmail_widgets;

my $READ_ONLY;

foreach my $s (@sendmail) {
        my $status = $s->status();
        if ($status->{read_only}) {
                $r->raise_error(&text('no_sm_suid'));
                $READ_ONLY = 1;
        }
}

updateStatus();

foreach my $sendmail (keys %sendmail_widgets) {
        my $sendmail_w = $sendmail_widgets{$sendmail}->{w};

        if ($sendmail_w->read_input($REQUEST)) {
          my $data = $sendmail_w->result_data();
          
          if($data->{start} or $data->{stop} or $data->{restart}) {
              my $s = $sendmail_widgets{$sendmail}->{s};
              my @pid;
              if ($s and ref($s) and $s->can('start') or $s->can('stop') or $s->can('restart')) {
                if ($data->{start}) {
                        push(@pid,$s->start( bg=>1)) if $data->{start};
                } elsif($data->{stop}) {
                        push(@pid,$s->stop( bg=>1)) if $data->{stop};
                } else {
                        push(@pid,$s->restart( bg=>1)) if $data->{restart};
                }
              }

              if (@pid) {
                      foreach (@pid) {
                        waitpid($_,0);
                        sleep(1); # sendmail takes a while to actually start
                        updateStatus();
                      }
              }
      
          } 
          else {
            RestartDlg();
          }
        }
        else {
            RestartDlg();
        }
}

foreach my $sendmail (keys %sendmail_widgets) {
        $r->add_part($sendmail_widgets{$sendmail}->{w},$sendmail . '_part');
}

$r->send();

# functions

sub updateStatus {
        undef(%sendmail_widgets);
        foreach my $sendmail (@sendmail) {
            
                my $name = $sendmail->name();
                my $raw_status = $sendmail->status( );
                my $status;
                my $flds;
                if (! defined $raw_status->{running} ) {
                        $status = {
                                        'Status' => "Unknown",
                                   }; 
                        $flds = ['Status'];
                }
                elsif ($raw_status->{running}) {
                        $status = {
                                        'Status' => &text('sendmail_running_desc','running'),
                                        'VM Size'    => $raw_status->{vsz},
                                        'Process Id' => $raw_status->{pid},
                                        'Ready' => $raw_status->{ready} ? 'Yes':'No',
                                   }; 
                        $flds = ['Status', 'Process Id', 'Ready', 'VM Size'];
                } else {
                        $status = { 
                                    'Status' => &text('sendmail_running_desc','stopped'),
                                  };
                        $flds = ['Status'];
                }

                my @buttons;
                push(@buttons, {type=>'image',icon=>'start', name=>'start',text=>'Start'}) 
                    if defined $sendmail->running and ! $sendmail->running;
                push(@buttons, {type=>'image',icon=>'restart',name=>'restart',text=>'Restart'},
                               {type=>'image',icon=>'stop',name=>'stop',text=>'Stop'} ) 
                    if $sendmail->running;

                my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                                     buttons => [ \@buttons, ], );

                my $new_widget = $r->Form(
                                            name => "sendmail_$name",
                                            data => $status,
                                            columns=>2,
                                            fields => $flds,
                                            title=>&text('sendmail_status_dialog_title',$name),
                                            toolbar => $READ_ONLY ? undef : $tb,
                                            action => 'index.cgi',
                                            keys => sub { return ucfirst(shift)},
                                            padding => '<BR> <BR> ',
                                           );
                 
                 $sendmail_widgets{$name} = { w=>$new_widget,s=>$sendmail};
        }
}

sub RestartDlg {
    if (smconfNewer()) {
        $r->print (<<EOT);
        <table class="tableRow" width="100%" cellspacing="0" cellpadding="1" border="0">
        <tr><td>
            <table width="100%" cellspacing="0" cellpadding="4" border="0">
            <tr><td class="tableRowAlt">
            Your sendmail configuration is newer than the settings sendmail is currently running. You must restart your sendmail server to
            make your recent changes active.
            </td></tr>
            </table>
        </td></tr>
        </table>
EOT
    }
}

1;

