#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use HTML::Template;
use PureMessage::Manager::CgiLogger qw(t d);
use PureMessage::Service::Sendmail qw(:all);
use PureMessage::Manager::Widget::ToolBar;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Services::Sendmail;
use PureMessage::Manager::Lang;
use PureMessage::Manager::Config qw(%config);
use PureMessage::_sys;

my $WIDGET = new PureMessage::Manager::Widget;
my $RESPONSE = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Sendmail',
                                       'stderr_to_stdout' =>1 );
$RESPONSE->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_sendmail_milt" );

my $WIDGET = new PureMessage::Manager::Widget;

my $DISABLED_CLASS = 'stopped';
my $ENABLED_CLASS = 'running';

my $action_msg = '';
my $toolbar_action = '';

eval{
# process the actions from URL
if ( $in{action}) {
	t"processing actions ...";
	#require './suid-lib.pl';
	my $action_txt = '';
	if(hasAllPerms()){
		my $result;
		if ( $in{action} eq "start" ) {
			t"running sendmail start";
			$result = run_suid(" -s start");
			$RESPONSE->log('Start service', '', 'sendmail');
			$action_txt = text('start_action_text');
			$toolbar_action = 'start';
			t"start result: $result";
		}
		elsif ( $in{action} eq "stop" ) {
			t"running sendmail stop";
			run_suid(" -s stop");
			$RESPONSE->log('Stop service', '', 'sendmail');
			$action_txt = text('stop_action_text');
			$toolbar_action = 'stop';
			t"stop result: $result";
		}
		elsif ( $in{action} eq "restart" ) {
			t"running sendmail restart";
			run_suid(" -s stop");
			t"stop result: $result";
			run_suid(" -s start");
			$REPONSE->log('Restart service', '', 'sendmail');
			$action_txt = text('restart_action_text');
			$toolbar_action = 'restart';
			t"start result: $result";
		}
	}else{
		$RESPONSE->raise_error('no_sm_suid');
		t("not configured to do this action");
	}
	t"updating the toolbar";
	#update_toolbar();
	if($action_txt){
		$action_msg = notification_str($action_txt);
	}
}


if($in{'d'} || $in{'disable'} ||$in{'disable.x'}){
	
	# disable a milter
	t"disable a milter";
	if(canEditMilters()){
	
		t"refresh the mc data";
		refresh_mc();
		foreach my $m (@milters) {
			next unless $m->{'name'} eq $in{'d'};
			t"disabling milter" . $m->{'name'};
			$m->{'enabled'} = 'disabled';
			$m->{'fail'} = 1 if lc($m->{'fail'}) eq 'r';
			$m->{'fail'} = 0 if lc($m->{'fail'}) eq 't';
			$m->{'fail'} = 2 if ! $m->{'fail'};
			t"saving milter data";
			my $rc = save_milter_data('edit', $m);
			$RESPONSE->log('Disable sendmail milter', '', $m->{'name'}, $m);
			t"save completed with rc = $rc";
			
			# these error codes must match the ones in the suid/milter_edit.c file
			# FIXME: these values need to be loaded from a module that imports the C symbols
			if($rc == 1){# sendmail was not found
				$RESPONSE->raise_error('err_no_sendmail');
			}elsif($rc == 4){ # milter name too long
				$RESPONSE->raise_error('name_len',25);
			}elsif($rc == 5){ # socket name too long
				$RESPONSE->raise_error('sock_len',265);
			}elsif($rc == 10){ # failed to convert a timeout value
				$RESPONSE->raise_error('timout_convert');
			}elsif($rc == 11){ #time out value too long
				$RESPONSE->raise_error('timeout_len',10);
			}elsif($rc != 0){
				# errors that this application should prevent or are unexpected
				$RESPONSE->raise_error('unexpected',$rc);
			}
		}
	}else{
		$RESPONSE->raise_error('no_sm_suid');
		t("suid programs not enabled");
	}
}

if($in{'e'} || $in{'enable'} ||$in{'enable.x'}){
	# enable a milter
	t"enable a milter";
	if(canEditMilters()){
		t"refreshing the mc data";
		refresh_mc();
		foreach my $m (@milters) {
			next unless $m->{'name'} eq $in{'e'};
			last if($in{'cancel'} || $in{'cancel.x'}); # don't bother if they selected cancel

			
			# check to see if this action has already been confirmed (socket is always checked the first time)
			unless($in{'confirmed'} || $in{'confirmed.x'}){
				# check socket connection
				my $sock_err;
				t"checking socket (connect)";
				unless(isMilterResponding($m->{'socket'}, \$sock_err)){
					# if socket failed, display a confirmation
					t"socket failed - display confirmation dialog";
					displayEnableConfirmation($m->{'name'});
				}
				t"socket ok";
			}
			
			# socket is working or they have confirmed so save the change
			t"setting the enable state";
			$m->{'enabled'} = 'enabled';
			$m->{'fail'} = 1 if lc($m->{'fail'}) eq 'r';
			$m->{'fail'} = 0 if lc($m->{'fail'}) eq 't';
			$m->{'fail'} = 2 if ! $m->{'fail'};
			t"saving milter data";
			my $rc = save_milter_data('edit', $m);
			$RESPONSE->log('Enable sendmail milter', '', $m->{'name'}, $m);
			t"save completed with rc = $rc";
			
			# these error codes must match the ones in the suid/milter_edit.c file
			# FIXME: these values need to be loaded from a module that imports the C symbols
			if($rc == 1){# sendmail was not found
				$RESPONSE->raise_error('err_no_sendmail');
			}elsif($rc == 4){ # milter name too long
				$RESPONSE->raise_error('name_len',25);
			}elsif($rc == 5){ # socket name too long
				$RESPONSE->raise_error('sock_len',265);
			}elsif($rc == 10){ # failed to convert a timeout value
				$RESPONSE->raise_error('timout_convert');
			}elsif($rc == 11){ #time out value too long
				$RESPONSE->raise_error('timeout_len',10);
			}elsif($rc != 0){
				# errors that this application should prevent or are unexpected
				$RESPONSE->raise_error('unexpected',$rc);
			}
		}
	}else{
		$RESPONSE->raise_error('no_sm_suid');
		t("suid program not enabled");
	}
}

$RESPONSE->title(text('milter_title'));

if ( ! $sm ) {
	# this error will be intergrated with sendmail module configuration interface
	t"sendmail was not installed";
	#raise_error("PureMessage-Sendmail is not found.");
	#error_dlg();
	#my $template = new HTML::Template(filename=>'tmpl/sendmailnotinstalled.html');
	#print $template->output;
  
  $RESPONSE->add_template( file => 'tmpl/sendmailnotinstalled.html', data=>{});
  #$RESPONSE->send();

} 
else 
{
	t"display sendmail status page", "get sendmail's status";
	my $expect = 'started' if($in{'action'} eq 'start' || $in{'action'} eq 'restart');
	$expect = 'stopped' if($in{'action'} eq 'stop');
	my $info = expect_sendmail_status($expect);

	t('check to see what mode it is running as');
	my $mode = 'hub';
	$mode = 'gateway' if isGateway();
	
    t"refresh the mc data";
    refresh_mc();
    
    my $fail = { "T" => "Temporary fail", "R" => "Reject connection" };
    my @milters_info;
    
	t"render milter data onto html template";
    foreach my $m (@milters) {
		my $milter_status;
		my $milter_class;
		my $commands;
		if($m->{'enabled'}){
			$milter_status = text('milter_enabled');
			$milter_class = $ENABLED_CLASS;
			$commands = ["milter.cgi?d=$m->{'name'}", '-disable', "Disable"];
		}else{
			$milter_status = text('milter_disabled');
			$milter_class = $DISABLED_CLASS;
			$commands = ["milter.cgi?e=$m->{'name'}", '-enable', "Enable"];
		} 
    # TODO all the dynamic buttons need to be done
    my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                              buttons => [[{ type=>'image', text=> 'Edit',icon=>'edit',
                                             href=>"milters.cgi?m=$m->{'name'}"
                                           },
                                         ]],
                              name => 'buttons' 
                            );
		push @milters_info, { NAME=>$m->{'name'}, 
                              SOCKET=>$m->{'socket'},
                              R=>$m->{'timeout'}->{'R'},
                              S=>$m->{'timeout'}->{'S'},
                              C=>$m->{'timeout'}->{'C'},
                              E=>$m->{'timeout'}->{'E'},
                              FAIL=>($fail->{$m->{'fail'}} || "Accept"),
                              LINE=>$m->{'line'},
							  STATUS_MSG=>$milter_status,
							  STATUS_CLASS=>$milter_class,
							  SECTION_HEADER=>$WIDGET->section_header("Input Mail Filter Configuration: $m->{'name'}"),
							  SECTION_FOOTER=>$RESPONSE->ThemeSectionFooter(toolbar=>$tb)->output(),
                             };
    }
    
	t"create template";
  #TODO get_system_hostname is missing
	my $template = HTML::Template->new(filename => 'tmpl/milter.html',die_on_bad_params=>0);
	$template->param(
                     HOSTNAME => PureMessage::_sys::gethostname(),
                     MILTERS  => \@milters_info,
					 RUN_MODE => $mode,
					 HAS_MILTERS => scalar @milters_info,
                    );
	if(canStartStop()){
		t("can start and stop; show the process info");
		$template->param(
					 VMSIZE   => $info->{vsz} || "",
					 PID      => $info->{pid} || "", 
					 CHILDREN => $info->{count} || "",
					 );
	}
	$template->param(CONF_CHANGED=>1) if smconfNewer();
	if(canStartStop()){
		t("all suid permissions are available");
		$template->param(SUID_OK=>1);
	}else{
		t("missing suid permissions on some or all files");
		$template->param(PMX_PREFIX=>$ENV{'PMX_PREFIX'});
		$template->param(SUID_MSG_HEADER=>$WIDGET->notification_header_str());
		$template->param(SUID_MSG_FOOTER=>$WIDGET->notification_footer_str());
	}

	if($action_msg){
		$template->param('HAS_ACTION_MSG'=>1);
		$template->param('ACTION_MSG'=>$action_msg);
		my $action_refresh_toolbar = 1;
		$template->param('ACTION_REFRESH_TOOLBAR'=>$action_refresh_toolbar);
		$template->param('TOOLBAR_ACTION'=>$toolbar_action);
	}
	
	t"template output";
	$RESPONSE->add_part($template,'body_template');
  #$RESPONSE->send();
  #print $template->output;  
	
}
t"cgi complete";
};
if($@){
	t"error while processing cgi: $@";
	$RESPONSE->raise_error("An error occured while processing the request: $@");
	$RESPONSE->error_dlg();
}
  $RESPONSE->send();


sub displayEnableConfirmation{
	my $name = shift;

	t"displayEnableConfirmation";
	# TODO:
	print theme_dialog_str(text('confirm_enable_bad_milter_title'),text('confirm_enable_bad_milter_msg',$name),
                     "-confirm",'milter.cgi',\%in,["confirmed",'-ok','Ok',"confirmed"],
                     ["cancel","-cancel","Cancel","cancel"]);
	#footer();	
	t"cgi complete";
	exit;
}


1;
