#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
use HTML::Template;
use PureMessage::Manager::CgiLogger qw(t d);
use PureMessage::Service::Sendmail qw(:all);
use PureMessage::Manager::Widget::ToolBar;
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Services::Sendmail;
use PureMessage::Manager::Lang;
use PureMessage::Manager::Config qw(%config);

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Sendmail',
                                       'stderr_to_stdout' =>1
                                     );
my $WIDGET = new PureMessage::Manager::Widget;

eval{
# process the actions from URL
t('update the toolbar');
#update_toolbar(); 
t('ok');

my $ping_fail = 0;
my $ping_ok = 0;
my $ping_err = '';

if ( ! $sm ) {
	t('sendmail is not installed');
    # this error will be intergrated with sendmail module configuration interface
    $r->raise_error("PureMessage-Sendmail is not found.");
}else{
	if($in{'add'} || $in{'add.x'}){
		t('add the new milter');
		add_milter();
		t('ok');
	}
	if($in{'save'} || $in{'save.x'}){
		t('save an edited milter');
		save_milter('edit');
		t('ok');
	}
	if($in{'ping'} || $in{'ping.x'} ){
		t('ping a milter');
		ping_milter($in{'ping_action'});
		t('ok');
	}
	if($in{'m'}){ #edit
		t('display the edit page');
		display_edit();
    
	}
	else{ # not edit
		t('display the add page');
		display_add();
	}
    
}
};
if($@){
	t("Error displaying page: $@");
	$r->raise_error("There was an error while processing the request. $@");
	$r->error_dlg();
        $r->send();
}

sub save_milter{
	my $type = shift;
	t('save_milter()');
	# if they canceled, go back to the edit screen
	
	display_edit() if ($in{'cancel'} || $in{'cancel.x'});
	
	# check to see if this action has already been confirmed (socket is always checked the first time)
	unless($in{'confirmed'} || $in{'confirmed.x'}){
		# check socket connection
		my $sock_err;
		t('check socket response');
		unless(isMilterResponding($in{'socket'}, \$sock_err)){
			# if socket failed, display a confirmation
			t('socket failed');
			displaySaveConfirmation($in{'name'}, 'edit');
		}
		t('ok');
	}	
	t('confirmed or socket is ok');
	
	
	my $ft = 0;
	$ft = 1 if lc($in{'fail'}) eq 'r';
	$ft = 2 if lc($in{'fail'}) eq 'a';
	my $rmilter = {	'name'=>$in{'name'}, 
					'socket'=>$in{'socket'}, 
					'fail'=>$ft, 
					'enabled'=>$in{'status'},
					'timeout'=>{
						'C'=>$in{'tc'},
						'R'=>$in{'tr'},
						'E'=>$in{'te'},
						'S'=>$in{'ts'}
						}
						
					};
	if($type eq 'edit'){
		unless(canEditMilters()){
			t("Sendmail has not been configured to allow milter edits");
			$r->raise_error('no_sm_suid');
			return display_index();
		}
			
		t('in edit mode, save the milter data');
		my $rc = save_milter_data($type, $rmilter);
		t("ok, rc = $rc");
		
		
		# detect and display error information for only some of the error codes. These
		# are the ones that the end user has control over.
		#
		# these error codes must match the ones in the suid/milter_edit.c file
		# FIXME: these values need to be loaded from a module that imports the C symbols
		if($rc == 1){# sendmail was not found
			$r->raise_error('err_no_sendmail');
		}elsif($rc == 4){ # milter name too long
			$r->raise_error('name_len',25);
		}elsif($rc == 5){ # socket name too long
			$r->raise_error('sock_len',265);
		}elsif($rc == 10){ # failed to convert a timeout value
			$r->raise_error('timout_convert');
		}elsif($rc == 11){ #time out value too long
			$r->raise_error('timeout_len',10);
		}elsif($rc != 0){
			# errors that this application should prevent or are unexpected
			$r->raise_error('unexpected',$rc);
		}
		if($rc!=0){
			t('redisplay the edit page');
			display_edit();
		}
		t('all went well, display the index');
		display_index();
	}
	t('done');
	
}

sub add_milter{
	my $ft = 0;
	
	t('add_milter()');
	
	# some basic input checks
	my $field;
	t('validate inputs');
	if(!add_milter_inputcheck(\$field)){
		t("input validation failed for: $field");
		$r->raise_error('input_validation', $field);
		display_add();
		return 0;
	}
		
	# if they canceled, go back to the edit screen
	display_edit() if ($in{'cancel'} || $in{'cancel.x'});
	
	# check to see if this action has already been confirmed (socket is always checked the first time)
	unless($in{'confirmed'} || $in{'confirmed.x'}){
		# check socket connection
		my $sock_err;
		t('check socket response');
		unless(isMilterResponding($in{'socket'}, \$sock_err)){
			# if socket failed, display a confirmation
			t('socket failed');
			displaySaveConfirmation($in{'name'}, 'edit');
		}
		t('ok');
	}	
	t('confirmed or socket is ok');
	
	$ft = 1 if lc($in{'fail'}) eq 'r';
	$ft = 0 if lc($in{'fail'}) eq 't';
	$ft = 2 if lc($in{'fail'}) eq 'a';
	my $rmilter = {	'name'=>$in{'name'}, 
					'socket'=>$in{'socket'}, 
					'fail'=>$ft, 
					'enabled'=>$in{'status'},
					'timeout'=>{
						'C'=>$in{'tc'},
						'R'=>$in{'tr'},
						'E'=>$in{'te'},
						'S'=>$in{'ts'}
						}
						
					};
	t('save the milter data');
	if(!canEditMilters()){
		$r->raise_error('no_sm_suid');
		return display_index();
	}
	my $rc = save_milter_data('add', $rmilter);
	t("ok, rc = $rc");
	
	
	# detect and display error information for only some of the error codes. These
	# are the ones that the end user has control over.
	#
	# these error codes must match the ones in the suid/milter_edit.c file
	# FIXME: these values need to be loaded from a module that imports the C symbols
	if($rc == 1){# sendmail was not found
		$r->raise_error('err_no_sendmail');
	}elsif($rc == 4){ # milter name too long
		$r->raise_error('name_len',25);
	}elsif($rc == 5){ # socket name too long
		$r->raise_error('sock_len',265);
	}elsif($rc == 10){ # failed to convert a timeout value
		$r->raise_error('timout_convert');
	}elsif($rc == 11){ #time out value too long
		$r->raise_error('timeout_len',10);
	}elsif($rc == 16){ # duplicate found
		$r->raise_error('duplicate_milter');
	}elsif($rc != 0){
		# errors that this application should prevent or are unexpected
		$r->raise_error('unexpected',$rc);
	}

	if($rc!=0){
		t('redisplay the add page');
		display_add();
	}
	t('all went well, display the index');
	display_index();
}

sub ping_milter{
	my $action = shift;
	t('ping_milter()');
	t('check if milter is responding');
	if(!isMilterResponding($in{'socket'}, \$ping_err)){
		t('failed');
		$ping_fail = 1;
	}else{
		t('ok');
		$ping_ok = 1;
	}
	t('redisplay the page');
	display_add() if(lc($action) eq 'add');
	display_edit() if(lc($action) eq 'edit');
	t('no action ?! check the input form for the action variable');
	$r->raise_error('internal_err_missing_ping_action');
	exit;

}


sub display_edit{
	t('display_edit');
	$r->title("Sendmail : " . text('editmilter_title'));
        $r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_sendmail_edit" );
	t('load template');
	my $template = HTML::Template->new(filename => 'tmpl/milters.html',die_on_bad_params=>0);
	t('get sendmail status');
	my $info = get_sendmail_status();
	t('ok');
	
	refresh_mc();
	
	my $fail = { "T" => text('temp_fail'), "R" => text('reject') };
	my $m_name = '';
	my $m_fail = '';
	my $m_status = '';
	if(!$in{'name'}){ # if no information available to edit, load it from the sendmail mc
		foreach my $m (@milters) {
		
			next unless $m->{'name'} eq $in{'m'};
			$m_name = $m->{'name'};
			$m_fail = $m->{'fail'};
			$m_status = $m->{'enabled'}?'e':'d';
			$template->param(NAME=>$m->{name}, 
								  SOCKET=>$m->{'socket'},
								  R=>$m->{timeout}->{R},
								  S=>$m->{timeout}->{S},
								  C=>$m->{timeout}->{C},
								  E=>$m->{timeout}->{E},
								  FAIL=>($fail->{$m->{'fail'}} || "Pass through"),
								  LINE=>$m->{line},
							);
		}
	}else{ # have information to edit
		$template->param('NAME'=>$in{'name'});
		$template->param('SOCKET'=>$in{'socket'});
		$template->param('R'=>$in{'tr'});
		$template->param('S'=>$in{'ts'});
		$template->param('C'=>$in{'tc'});
		$template->param('E'=>$in{'te'});
		$template->param('line'=>$in{'line'});
		$m_fail = $in{'fail'};
		$m_status = $in{'status'};		
	}

	if(lc($m_fail) eq 't'){
		$template->param(TEMPFAIL_SEL=>'selected');
	}elsif(lc($m_fail) eq 'r'){
		$template->param(REJECT_SEL=>'selected');
	}

	if(lc($m_status) eq 'e' || lc($m_status) eq 'enabled'){
		$template->param(ENABLED_SEL=>'selected');
	}elsif(lc($m_status) eq 'd' || lc($m_status) eq 'disabled'){
		$template->param(DISABLED_SEL=>'selected');
	}

	if($ping_fail){
		$template->param(PING_STATUS=>$ping_err);
	}
	if($ping_ok){
		$template->param(PING_STATUS=>text('ping_ok'));
	}

	$template->param(ACTION=>'edit');
	$template->param(SECTION_HEADER=>$WIDGET->section_header("Edit Mail Filter Configuration"));
        my $tb = $WIDGET->widget( CLASS => 'PureMessage::Manager::Widget::ToolBar',
                                  buttons=> [[
                                                { type=>'image',name=>'save',text=>'Save',value=>'save',icon=>'save'},
                                            ]],
                                );
	$template->param(SECTION_FOOTER=>$r->ThemeSectionFooter(toolbar=>$tb)->output());
	t('display the template');
	$r->add_part($template,'body_data');
        $r->send();
	t('all done');
	exit;
}

sub display_add{
	t('display_add()');
	$r->title("Sendmail: " . text('add_title'));
        $r->add_help("About This Page", "mgr/mgr_locserv_sendmail_edit" );
        $r->add_help("Administrator's Reference: <br>&nbsp;&nbsp; Edit Sendmail Milters", "services", "sendmail_config" );
	t('load template');
	my $template = HTML::Template->new(filename => 'tmpl/milters.html',die_on_bad_params=>0);		
	t('ok');
	$template->param(SECTION_HEADER=>$WIDGET->section_header(text('add_header')));
	$template->param(SECTION_FOOTER=>$r->ThemeSectionFooter(
                                             toolbar => $r->ToolBar(
                                                          buttons => [[
                                                                       { type=>'image',
                                                                         name=>'add',
                                                                         text=>'Add',
                                                                         value=>'add',
                                                                         icon=>'save',
                                                                       }
                                                                     ]]))->output);
	$template->param(ADDMODE=>1);
	
	my $m_fail = '';
	my $m_status = '';
	if($in{'name'} || $in{'socket'}){ # have something to modify (probably displaying a failed add attempt)
		$template->param('NAME'=>$in{'name'});
		$template->param('SOCKET'=>$in{'socket'});
		$template->param('R'=>$in{'tr'});
		$template->param('S'=>$in{'ts'});
		$template->param('C'=>$in{'tc'});
		$template->param('E'=>$in{'te'});
		$template->param('line'=>$in{'line'});
		$m_fail = $in{'fail'};
		$m_status = $in{'status'};
	}
	if(lc($m_fail) eq "t"){
		$template->param(TEMPFAIL_SEL=>'selected');
	}elsif(lc($m_fail) eq "r"){
		$template->param(REJECT_SEL=>'selected');
	}
	
	if(lc($m_status) eq 'e' || lc($m_status) eq 'enabled'){
		$template->param(ENABLED_SEL=>'selected');
	}elsif(lc($m_status) eq 'd' || lc($m_status) eq 'disabled'){
		$template->param(DISABLED_SEL=>'selected');
	}

	
	# parameters for getting ping information
	$template->param(ACTION=>'add');	
	if($ping_fail){
		$template->param(PING_STATUS=>$ping_err);
	}
	if($ping_ok){
		$template->param(PING_STATUS=>text('ping_ok'));
	}
	t('display template');
	$r->add_part($template,'body_data');  
        $r->send();
	t('all done');
	exit;
	
}

sub display_index{
	t('display the index');
	require './milter.cgi';
	t('all done');
	exit;
}

sub add_milter_inputcheck{
	my $rfield = shift;
	t('add_milter_inputcheck()');
	$$rfield = "Name";
	return 0 if $in{'name'} =~ /[^a-zA-Z0-9\-_:]/; #only allow these milter names
	$$rfield = "Socket";
	return 0 if $in{'socket'} =~ /[^a-z-A-Z0-9\-_\/\.:\@]/; # note, backslash is not allowed, should it be?
	$$rfield = "Fail Mode";
	return 0 if $in{'fail'} !~ /r|t|a/;
	$$rfield = "Status";
	return 0 if $in{'status'} !~ /enabled|disabled|e|d/;
	$$rfield = "Timeout R";
	return 0 if $in{'r'} =~ /[^\d]/;
	$$rfield = "Timeout S";
	return 0 if $in{'s'} =~ /[^\d]/;
	$$rfield = "Timeout C";
	return 0 if $in{'c'} =~ /[^\d]/;
	$$rfield = "Timeout E";
	return 0 if $in{'e'} =~ /[^\d]/;
	t('ok');
	return 1;
}

sub displaySaveConfirmation{
	my $name = shift;
	my $mode = shift;
	t('displaySaveConfirmation()');
	if(lc($mode) eq 'edit'){
                $r->title("Sendmail: " . text('edit_title'));
	}else{
		$r->title("Sendmail: " . text('add_title'));
	}
	t('display the dialog');
        $r->dialog(style=>'DLG_QUERY',
                   dialog_title=>text('confirm_save_bad_milter_title'),
                   msg =>text('confirm_save_bad_milter_msg',$name),
                   state=>\%in,
		   embed =>0,
                   toolbar=>$WIDGET->widget('CLASS' => 'PureMessage::Manager::Widget::ToolBar',
		   	action=>$ENV{SCRIPT_NAME},
		   	buttons =>[[
                              { type=>'image',name=>'confirmed',text=>'Ok',value=>'confirmed'},
                              { type=>'image',name=>'cancel',text=>'Cancel',value=>'cancel'},
                            ]]),
        );
	#print theme_dialog_str($text{'confirm_save_bad_milter_title'},text('confirm_save_bad_milter_msg',$name),
        #             "-confirm",'milters.cgi',\%in,["confirmed",'-ok','Ok',"confirmed"],
        #             ["cancel","-cancel","Cancel","cancel"]);
	$r->send();
	t('ok');
	exit;
}


