#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
# wz_gatewayconf.cgi
# sendmail gateway configuration wizard

use HTML::Template;
use Data::Dumper;
use PureMessage::Manager::CgiWizard qw(w_run w_save_state w_get_state w_is_done w_raise_error);
use PureMessage::Manager::CgiLogger qw(t d);
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Services::Sendmail;
use PureMessage::Manager::Lang;
use PureMessage::Manager::Config qw(%config);
use PureMessage::Service::Sendmail qw(:all);
use strict;

my $rw = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Sendmail',
                                       'stderr_to_stdout' =>1
                                     );

$rw->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_sendmail_wiz_gate" );

$rw->{debug} = 0;

my $WIDGET = new PureMessage::Manager::Widget;






my $SEND = 1;
eval{
	my @wizard = ({'title'=>text('relay_host_header'), 'action'=>\&relay_hosts_action, 'display'=>\&relay_hosts_display},
				{'title'=>text('relay_domains_header'), 'action'=>\&relay_domains_action, 'display'=>\&relay_domains_display}, 
				{'title'=>text('gateway_conf_finish'), 'action'=>\&final_action, 'display'=>\&final_display} 
				);
	my $reason;
	t"running the wizard";
	if(!w_run(text('gateway_conf_title'), 'wz_gatewayconf.cgi', 'index.cgi', \@wizard, \%in, \$reason,1,$rw)){
		t"wizard failed, reason is $reason";
		$rw->print("Wizard failed for some reason ...\n");
	}

	if(w_is_done()){
		t"wizard has completed all steps, display the index status page.";
                $SEND = 0;
                require './index.cgi';
                exit;
	}
	t"script complete";
};
if($@){
	t"error processing request: $@";
	$rw->raise_error("There was an error while processing the request: $@");
	$rw->error_dlg();
        $rw->send();
        exit;
}

$rw->send() if $SEND;

 ######################################################################
# functions to process the relay hosts information
sub relay_hosts_action{
	my $cgi = shift;
	my $reason = shift;
	t('relay_hosts_action()');
	if($$cgi{'relay_hosts'}){
		
		# input validation:
		# data must be in \n delimited records & white space separated fields
		my @rows = split "\n",$$cgi{'relay_hosts'};
		my $ok_data = '';
		t('validate the input');
		foreach my $row(@rows){
			$row =~ s/\s*$//;
			$row =~ s/^\s*//;
			if($row){
				$row =~ /([\S]+)([\s]+)([\S]+)$/;
				if(!$1){
					t("relay domain is missing from $row");
					w_raise_error('missing_relay_dom', $row);
					return 0;
				}
				if(!$3){
					t("relay host is missing from $row");
					w_raise_error('missing_relay_host', $row);
					return 0;
				}
				$ok_data .= "$row\n";
			}
		}
			
		# it all checks out, save the values for later
		t('data validated ok', 'save relay state');
		w_save_state('relay_hosts', {'relay_hosts'=>$ok_data});
	}else{
		t('no relay host information was submitted to the cgi');
		w_raise_error('missing_relay_hosts');
		return 0;
	}
	return 1;
}
sub relay_hosts_display{
	my $cgi = shift;
	my $reason = shift;	
	
	eval{
		t('relay_hosts_display()','load the template');
		my $template = new HTML::Template(filename=>'tmpl/wzp_relay_hosts.html', die_on_bad_params=>0);
		
		# load the existing settings from the config file
		t('refresh the mailer table data');
		refresh_mailertable();
		t('ok');
		
		my $mtdata = "";
		foreach my $line(@relay_hosts){
			$mtdata .= "$line->[0]\n";
		}
		#my $mtdata = join("\n", @relay_hosts);
		$template->param('RELAY_HOSTS'=>$mtdata);
		
		if(my $rh = w_get_state('relay_hosts')){
			t('get the existing relay hosts data from the wizard state');
			if(my $hosts = $$rh{'relay_hosts'}){
				$template->param('RELAY_HOSTS'=>$hosts);
			}
		}
		if($$cgi{'relay_hosts'}){
			t('get the existing relay hosts data from the cgi post');
			$template->param('RELAY_HOSTS'=>$$cgi{'relay_hosts'});
		}
		$rw->add_part($template,'body_hosts_display');
	}; if($@){
		t("error displaying template: $@");
		$rw->raise_error("Failed to display template.Reason: $@");
		$rw->error_dlg();
	}
	t("display complete");
	return 1;
}

######################################################################
# functions to process the relay domains information
sub relay_domains_action{
	my $cgi = shift;
	my $reason = shift;
	my $data = $$cgi{'relay_domains'};
	$data =~ s/^\s*//;
	$data =~ s/\s*$//;

	t('relay_domains_action()');
	if($data){
		
		# data must be in \n delimited records & and not contain and white space
		t('verify and save data in wizard state');
		my @rows = split "\n",$data;
		for(my $i=0; $i<=$#rows;$i++){
			my $row = $rows[$i];
			$row =~ s/\s*$//;
			$row =~ s/^\s*//;
			unless($row){
				t("the domain was missing from $row");
				w_raise_error('missing_allow_relay_dom', ($i+1), $row);
				return 0;
			}
			if($row=~/\s+/){
				t("the domain contained a space in $row");
				w_raise_error('relay_dom_space',($i+1),$row);
				return 0;
			}
			if($row=~/[^a-zA-Z0-9.\-\_]/){ # only allow a fairly restrictive set of characters. should be enough to specify domains, hosts & ip address
				t("the domain contained invalid characters in $row");
				w_raise_error('relay_host_bad_char',($i+1));
				return 0;
			}
		}		
		t("validation ok", "save state");
		w_save_state('relay_domains',{'relay_domains'=>$$cgi{'relay_domains'}});	
	}else{
		t("missing relay_domains post data");
		w_raise_error('missing_relay_domains');
		return 0;
	}
	t("action complete");
	return 1;
}
	
sub relay_domains_display{
	my $cgi = shift;
	my $reason = shift;	
	t('relay_domains_display()');
	
	eval{
		t("load template");
		my $template = new HTML::Template(filename=>'tmpl/wzp_relay_domains.html', die_on_bad_params=>0);
		
		# load the existing settings from the config file
		t('refresh the access table data');
		refresh_accesstable();
		t('ok');
		my $rddata = "";
		foreach my $line(@access_table){
			$rddata .= "$line->[0]\n";
		}
		$template->param('RELAY_DOMAINS'=>$rddata);			
		
		if(my $rd = w_get_state('relay_domains')){
			t('get the existing relay domains data from the wizard state');
			if(my $hosts = $$rd{'relay_domains'}){
				$template->param('RELAY_DOMAINS'=>$hosts);
			}
		}
		
		if($$cgi{'relay_domains'}){
			t('get the existing relay domains data from the cgi post');
			$template->param('RELAY_DOMAINS'=>$$cgi{'relay_domains'});
		}	
		t('display the template');
		$rw->add_part($template,'body_domains_display');
	}; 
        if($@){
		t("Error in display: $@");
		$rw->raise_error("An error occured while displaying the relay domains. $@");
		$rw->error_dlg();
	}
	t('display complete');
	return 1;
}

######################################################################
# fucntions to process the final wizard page. The action function
# takes all the informaion gathered in the wizard, applys (saves) the
# data and attempts to restart the server (if the user has selected that).
#
sub final_display{
	my $cgi = shift;
	my $reason = shift;	
	t('final_display()');	
	eval{
		t('load the template');
		my $template = new HTML::Template(filename=>'tmpl/wzp_relay_save.html', die_on_bad_params=>0);
		t('get all the wizard state data');
		my $all = w_get_state();
		t('ok');
		$template->param('RELAY_HOSTS'=>$all->{'relay_hosts'}{'relay_hosts'});
		$template->param('RELAY_DOMAINS'=>$all->{'relay_domains'}{'relay_domains'});
		
		t('check to see if sendmail is running');
		if(isSendmailRunning()){
			t('yes');
			$template->param('START_MSG'=>text('restart_sendmail'));
			$template->param('STARTED_MSG'=>text('restarted_sendmail'));
		}else{
			t('no');
			$template->param('START_MSG'=>text('start_sendmail'));
			$template->param('STARTED_MSG'=>text('started_sendmail'));
		}
		t('display template');
		$rw->add_part($template,'body_display');
	}; 
        
        if($@) {
		t("Error in display: $@");
		$rw->raise_error("An error occured while displaying the page. $@");
		$rw->error_dlg();
	}
	t('display complete');
	return 1;
}
sub final_action{
	my $cgi = shift;
	my $reason = shift;	
	my $rc;

	unless(canEditMailerTable() && canEditAccessTable() && canStartStop()){
		t("Sendmail has not been configured to allow edites to the mailter table or access table");
		$rw->raise_error('no_sm_suid');
		return 1;
	}
	# save the data
	t('final_action()');
eval{
	t("check what mode sendmail is running as now, if gateway, don't touch the mc file.","if not, make the mc file a gateway file");
	unless(isGateway()){
		t("not a gateway, make it one");
		refresh_mc();
		$rc = makeGateway();
		if($rc){ # C-style return code (0 == ok)
			t("failed: $rc");
			die ("Failed to make sendmail a gateway. Failed to copy the example mc file. $rc");
		}
		# Put the milters back in the config
		foreach my $m (@milters) {
		    $m->{'enabled'} = $m->{'enabled'} ? 'enabled':'disabled';
		    $m->{'fail'} = 1 if lc($m->{'fail'}) eq 'r';
		    $m->{'fail'} = 0 if lc($m->{'fail'}) eq 't';
		    $m->{'fail'} = 2 if ! $m->{'fail'};
		    $rc = save_milter_data('add', $m);
		    if ($rc) {
			t("failed to add milters: $rc");
			die("Failed to add milters to gateway. $rc");
		    }
		}
	}
	t("ok");
	t('get the relay hosts wizard state data');
	my @rows = split "\n", w_get_state('relay_hosts')->{'relay_hosts'};
	t('ok','save all the mailer table data');
	save_mailer_table(@rows);
	t('ok');
	
	t('get the relay domains wizard state data');
	my @access_rows = split "\n", w_get_state('relay_domains')->{'relay_domains'};
	s/\r// foreach @access_rows;
	t('ok','save the access table data');
	save_access_table(@access_rows);
	t('ok');
	
	# start or restart sendmail if we've been asked to.
	t('Need to start sendmail?');
	if($$cgi{'start_sendmail'}){
		t('yes','start or restart?');
		if(isSendmailRunning()){
			t('restart');
			run_suid('-s stop');
			run_suid('-s start');
			t('restart done');
		}else{
			t('start');
			run_suid('-s start');
			t('start done');
		}
	}
};if($@){
	t("Error in final action: $@");
	w_raise_error("There was an error while processing this request. $@");
	return 0;
}
	t('action complete');
	return 1;
		
}

1;
	
