#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl
# wz_hubconf.cgi
# sendmail hub configuration wizard

use HTML::Template;
use Data::Dumper;
use PureMessage::Manager::CgiWizard qw(w_run w_save_state w_get_state w_is_done w_raise_error);
use PureMessage::Manager::CgiLogger qw(t d);
use PureMessage::Manager::Request qw($REQUEST %in %text);
use PureMessage::Manager::Response::Services::Sendmail;
use PureMessage::Manager::Lang;
use PureMessage::Manager::Config qw(%config);
use PureMessage::Service::Sendmail qw(:all);
use strict;

my $rw = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::Sendmail',
                                       'stderr_to_stdout' =>1
                                     );

$rw->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_sendmail_wiz_hub" );

my $WIDGET = new PureMessage::Manager::Widget;

our (%text, %in, @relay_hosts, @access_table);
my $SEND = 1;

eval{
my @wizard = ({'title'=>text('hub_conf_finish'), 'action'=>\&final_action, 'display'=>\&final_display} );
my $reason;
if(!w_run(text('hub_conf_title'), 'wz_hubconf.cgi', 'index.cgi', \@wizard, \%in, \$reason,1,$rw)){
	# FIXME: need a better error message here.
	$rw->raise_error("Wizard failed: $reason");
	$rw->error_dlg();
        $rw->send;
	exit;
}

if(w_is_done()){
	# Wizard has completed ... load the index page
        $SEND = 0;
        require './index.cgi';
        exit;
}
};
if(@!){
	t("Error: $@");
	# FIXME : hardcoded error string - put in the language file
	$rw->raise_error("An error occured while processing the request. $@");
        $rw->error_dlg();
        $rw->send();
        exit;
}

$rw->send() if $SEND;
######################################################################
# fucntions to process the final wizard page. The action function
# takes all the informaion gathered in the wizard, applys (saves) the
# data and attempts to restart the server (if the user has selected that).
#
sub final_display{
	my $cgi = shift;
	my $reason = shift;	
	t('final_display');	
	eval{
		my $template = new HTML::Template(filename=>'tmpl/wzp_hub_save.html', die_on_bad_params=>0);
		if(isSendmailRunning()){
			$template->param('START_MSG'=>text('restart_sendmail'));
			$template->param('STARTED_MSG'=>text('restarted_sendmail'));
		}else{
			$template->param('START_MSG'=>text('start_sendmail'));
			$template->param('STARTED_MSG'=>text('started_sendmail'));
		}		
		$rw->add_part($template->output,'body_text');
	}; if($@){
		t("Error in display. $@");
		$rw->raise_error("Error displaying template! $@");
		$rw->error_dlg();
                $rw->send();
		return 0;
	}
	t('done final_display');
	return 1;
}
sub final_action{
	my $cgi = shift;
	my $reason = shift;	
	my $rc;

	unless(canStartStop()){
		t("Sendmail has not been configured to change configuration files.");
		$rw->raise_error('no_sm_suid');
		return 1;
	}
	# save the data
	t('make it a hub or do nothing if it already is a hub');
	if(isGateway()){
		t('is a gateway, make it a hub');
		refresh_mc();
		$rc = makeHub();
		if($rc){ # C-style error code (0 == ok)
			# FIXME : hardcoded string - put in lang file
			t("failed to make it a hub: $rc");
			die "Failed to make sendmail into a hub. Could not copy example mc file to sendmail.mc";
		}
		# Put the milters back in the config
		foreach my $m (@milters) {
		    $m->{'enabled'} = $m->{'enabled'} ? 'enabled':'disabled';
		    $m->{'fail'} = 1 if lc($m->{'fail'}) eq 'r';
		    $m->{'fail'} = 0 if lc($m->{'fail'}) eq 't';
		    $m->{'fail'} = 2 if ! $m->{'fail'};
		    $rc = save_milter_data('add', $m);
		    if ($rc) {
			t("failed to add milters: $rc");
			die("Failed to add milters to hub. $rc");
		    }
		}
		t("is now a hub");
	} 
	t("restart sendmail?");
	# start or restart sendmail if we've been asked to.
	if($$cgi{'start_sendmail'}){
		t("yes", "restart or start?");
		if(isSendmailRunning()){
			t("restart", "sendmail stop");
			run_suid('-s stop');
			t("ok","sendmail start");
			run_suid('-s start');
			t("ok");
		}else{
			t("start", "sendmail start");
			run_suid('-s start');
			t("ok");
		}
	}
	t("final_action done");
	return 1;
}

1;
	
